<template>
  <PDialog
    v-model:visible="displayModal"
    modal
    :header="
      t('component.cloneBusinessCase.title', { name: businessCase.name })
    "
    class="CloneBusinessCaseDialog"
  >
    <!-- Code -->
    <label class="CloneBusinessCaseDialog__Label CloneBusinessCaseDialog__Code">
      <span class="CloneBusinessCaseDialog__LabelTxt">{{
        t('resource.business_case.code')
      }}</span>
      <PInputText v-model="code" type="text" />
      <ErrorWrapper :errors="errors.code" />
    </label>

    <!-- Name -->
    <label class="CloneBusinessCaseDialog__Label CloneBusinessCaseDialog__Name">
      <span class="CloneBusinessCaseDialog__LabelTxt">{{
        t('resource.business_case.name')
      }}</span>
      <PInputText v-model="name" type="text" />
      <ErrorWrapper :errors="errors.name" />
    </label>

    <!-- Action buttons -->
    <template #footer>
      <PButton
        :label="t('action.cancel')"
        icon="pi pi-times"
        class="p-button-text p-button-secondary"
        @click="hideDialog"
      />
      <PButton
        type="button"
        :label="t('action.clone')"
        icon="pi pi-check"
        class="p-button-text"
        :disabled="!isValid"
        @click="submit"
      />
    </template>
  </PDialog>
</template>
<script lang="ts" setup>
import { BusinessCase, businessCaseClient } from '@/api'
import { computed, ref } from 'vue'
import { useRouter } from 'vue-router'
import { ROUTES } from '@/plugins'
import { useFormValidation } from '@/components/form'
import { useI18n } from 'vue-i18n'
import { addMessage } from '@/states'
import { AxiosError } from 'axios'

const { errors, clearErrors, parseViolations } = useFormValidation()
const { t } = useI18n()
const router = useRouter()
const props = defineProps<{
  visible: boolean
  businessCase: BusinessCase
}>()
const name = ref<string>('')
const code = ref<string>('')

const emit = defineEmits<{
  (e: 'update:visible', value: boolean): void
}>()

/**
 * Whether user input is valid
 */
const isValid = computed((): boolean => {
  return Boolean(name.value.length && name.value.length)
})

/**
 * Modal dialog visibility
 */
const displayModal = computed({
  get: () => props.visible,
  set: (value: boolean) => emit('update:visible', value),
})

function hideDialog() {
  displayModal.value = false
  clearErrors()
}

/**
 * Clone business case and redirect
 */
async function submit() {
  clearErrors()
  if (!isValid.value) return

  try {
    const resource = await businessCaseClient.clone(
      props.businessCase.id,
      name.value,
      code.value
    )
    addMessage({
      severity: 'success',
      life: 5000,
      summary: t('component.cloneBusinessCase.cloned'),
    })
    hideDialog()
    await router.push({
      ...ROUTES.BUSINESS_CASE,
      params: { uuid: resource.id },
    })
  } catch (e) {
    const response = (e as AxiosError)?.response
    if (response?.status === 422) {
      parseViolations(response.data.violations)
      return
    }
    console.error(e)
  }
}
</script>

<style lang="scss" scoped>
@use 'src/style/variables' as v;

.CloneBusinessCaseDialog {
  &__Label {
    display: flex;
    flex-direction: column;

    &Txt {
      margin: v.$spacing-4 0;
    }
  }
}
</style>
